## Nathan Kraft- nkraft@biodiversity.ubc.ca
## R-function to identify terminal polytomies, then randomly thin those 
## polytomies until only 'keep' number of taxa remain in each polytomy.
## Designed to work on an object of class "phylo" as defined in the R-
## package, ape (Paradis et al. 2004 ).


thin_terminal_polytomies=function(phy, keep=1){
	
	require(ape)
	
	phy$edge->edges
	length(phy$tip.label)->ntips
	edges[which(edges[,2]<=ntips),]->terminal_edges
	
	if(sum(table(terminal_edges[,1])>2)==0){
		print("no polytomies- returning original tree")
		return(phy)
		
	}
	
	names(which(table(terminal_edges[,1])>2))->poly_list
	
	droplist<-NULL
	for(i in 1:length(poly_list)){
		
		terminal_edges[which(terminal_edges[,1]==poly_list[i]),2]->tips
		droplist<-c(droplist, sample(tips, size=(length(tips)-keep)))
		
	}
	
	drop.tip(phy, droplist)->phy_thin
	
	return(phy_thin)
}
